import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;
import java.awt.Point;
/**
 * Write a description of class BaseActor here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BaseActor extends SmoothMover
{
    private GreenfootImage collisionImage = null;
    boolean hasCollision = true; //overide if your entetie does not have collistion

    public final void addedToWorld(World w) {
        try {
            addedToWorld((PlayWorld) w);
        }catch(ClassCastException e) {
        }        
    }

    public boolean isTouching(Class c) {
        GreenfootImage myOldImage = getImage();
        List<BaseActor> others = (List<BaseActor>) getWorld().getObjects(c);
        List<GreenfootImage> oImages = new ArrayList<GreenfootImage>();
        for(BaseActor a : others) {
            oImages.add(a.getImage());
        }
        
        for(BaseActor a : others) {
            a.setImage(a.getCollisionImage());
        }    
        setImage(getCollisionImage());        
        boolean value = super.isTouching(c);
        setImage(myOldImage);
        for(int i = 0; i < others.size();i++) {
            others.get(i).setImage(oImages.get(i));
        }
        return value;
    }

    public BaseActor getOneIntersectingObject(Class c) {
        GreenfootImage myOldImage = getImage();
        List<BaseActor> others = (List<BaseActor>) getWorld().getObjects(c);
        List<GreenfootImage> oImages = new ArrayList<GreenfootImage>();
        for(BaseActor a : others) {
            oImages.add(a.getImage());
        }
        
        for(BaseActor a : others) {
            a.setImage(a.getCollisionImage());
        }    
        setImage(getCollisionImage());        
        BaseActor value = (BaseActor) super.getOneIntersectingObject(c);
        setImage(myOldImage);
        for(int i = 0; i < others.size();i++) {
            others.get(i).setImage(oImages.get(i));
        }
        return value;
    }

    public List<BaseActor> getIntersectingObjects(Class cls) {
        GreenfootImage myOldImage = getImage();
        List<BaseActor> others = (List<BaseActor>) getWorld().getObjects(cls);
        List<GreenfootImage> oImages = new ArrayList<GreenfootImage>();
        for(BaseActor a : others) {
            oImages.add(a.getImage());
        }
        
        for(BaseActor a : others) {
            a.setImage(a.getCollisionImage());
        }    
        setImage(getCollisionImage());        
        List<BaseActor> value = (List<BaseActor>) super.getOneIntersectingObject(cls);
        setImage(myOldImage);
        for(int i = 0; i < others.size();i++) {
            others.get(i).setImage(oImages.get(i));
        }
        return value;
    }
    
    public void setWorldLoc(double x,double y) {
        changeLoc(x-getWorldX(),y-getWorldY());    
    }
    
    public void setWorldX(double x) {
        changeLoc(x-getWorldX(),0);
    }
    
    public void setWorldY(double y) {
        changeLoc(y-getWorldY(),0);
    }

    //does not facture in rotation
    /*public boolean isTouching(BaseActor a) {
        GreenfootImage myOldImage = getImage();
        GreenfootImage hisOldImage = a.getImage();
        setImage(getCollisionImage());
        a.setImage(a.getCollisionImage());
        boolean value = super.getIntersectingObjects(a.getClass()) == a;
        setImage(myOldImage);
        a.setImage(hisOldImage);
        return value;
        
        /*if(getRotation()-a.getRotation() > 10) return super.getIntersectingObjects(a.getClass()).contains(a);        
        GreenfootImage myC = getCollisionImage();
        GreenfootImage hisC = a.getCollisionImage();
        double dx = Math.abs(getExactX()-a.getExactX()); //the x difference        
        double dy = Math.abs(getExactY()-a.getExactY()); //the y difference
        if(dx > myC.getWidth()+hisC.getWidth() || dy > myC.getHeight()+hisC.getHeight()) return false;

        int myXoverlap = getX()-a.getX(); 
        int myYoverlap = getY()-a.getY();
        List<int[]> overlapingPixels = new ArrayList<int[]>();
        for(int x = 0; x < Math.abs(myXoverlap); x++) {            
            int pixelX = x;
            if(myXoverlap < 0) pixelX = myC.getWidth()-pixelX;

            for(int y = 0; y < Math.abs(myYoverlap); y++) {
                int pixelY = y;
                if(myYoverlap < 0) pixelY = myC.getHeight()-pixelY;
                overlapingPixels.add(new int[] {pixelX,pixelY});
            }           
        }

        for(int[] pixel : overlapingPixels) {
            if(pixel[0]<myC.getWidth() && pixel[1]<myC.getHeight()) {
                if(myC.getColorAt(pixel[0],pixel[1]).getAlpha() < 150) {
                    int hisX = pixel[0]-(getX()-a.getX());
                    int hisY = pixel[1]-(getY()-a.getY());
                    if(hisX<hisC.getWidth() && hisY < hisC.getHeight()) {
                        if(hisC.getColorAt(hisX,hisY).getAlpha() < 150) return true;
                    }                
                }     
            }       
        }   return false;*/  
        
    

    public void changeLoc(double dx,double dy) {
        setLocation(getExactX()+dx,getExactY()+dy);
    }

    public void addedToWorld(PlayWorld w) {

    }

    public final void act() 
    {
        run();
        if(Greenfoot.mouseClicked(this)) onClick();
    }    

    public void run() {

    }

    public void onClick() {

    }

    public double getWorldX() {
        return ((PlayWorld) getWorld()).centreX+getExactX();
    }

    public double getWorldY() {
        return ((PlayWorld) getWorld()).centreY+getExactY();
    }
    
    public Point getWorldLoc() {
        Point p = new Point(0,0);
        p.setLocation(getWorldX(),getWorldY());
        return p;
    }

    //return +1 / -1
    public int randomSign() {
        int sign = (int) Math.round(Math.random());
        if(sign == 0) return -1;
        return sign;
    }

    public void setCollisionImage(GreenfootImage i) {
        collisionImage = i;
    }

    public GreenfootImage getCollisionImage() {
        if(collisionImage == null) return getImage();
        return collisionImage;
    }
}

