import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import javax.swing.JOptionPane;
import java.util.List;
import fejfo.MessageHandler;
import java.util.ArrayList;
import java.util.List;
import java.io.IOException;
import java.awt.Point;
/**
 * Write a description of class MultiplayerWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PlayWorld extends World implements MessageHandler
{
    int numberOfPlayers;    
    /**
     * Constructor for objects of class MultiplayerWorld.
     * 
     */
    public PlayWorld(double startCentreX,double startCentreY)
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1,false); 
        centreX = startCentreX;
        centreY = startCentreY;            
    }

    int players = -1;    
    public void addPlayer(Player pl,double wx,double wy) {      
        players++;
        int x = (int) (wx-centreX); 
        int y = (int) (wy-centreY);
        addObject(pl,x,y);        
    }

    double centreX = 0;
    double centreY = 0;
    public void move(BaseActor caller,double dx,double dy) {
        centreX+=dx;
        centreY+=dy;
        for(BaseActor a : (List<BaseActor>) getObjects(BaseActor.class)) {
            if(a != caller) {
                a.setLocation(a.getExactX()-dx,a.getExactY()-dy);
            }
        }
    }

    public void move(double dx,double dy) {
        move(null,dx,dy);
    } 
    
    public void addObjectAt(BaseActor o,double wx,double wy) {
        addObject(o,0,0);
        o.setWorldLoc(wx,wy);
    }

    public String playerID = null;
    public long age = System.currentTimeMillis();
    public List<String> knowIDs = new ArrayList<String>();
    public boolean multiplayer = false;
    public void reicive(String data) {
        if(multiplayer == false) return;

        //try {
        String[] parts = data.split(":");
        String name = parts[0];
        if(name.equalsIgnoreCase("JoinEvent")) {
            String info = parts[1];
            String[] infoParts = info.split(";");
            double x = Double.valueOf(infoParts[0]);
            double y = Double.valueOf(infoParts[1]);
            //playerID = infoParts[2]+=r.nextLong();
            knowIDs.add(infoParts[2]);
            //age = System.currentTimeMillis();                        
            addPlayer(new Player(infoParts[2]),x,y);               
        }else if(name.equalsIgnoreCase("Request")) {
            String subName = parts[1];
            if(subName.equalsIgnoreCase("playerID")) {
                Join.send("Anser:playerID:"+playerID+";"+age);
            }else if(subName.equalsIgnoreCase("playerDATA")) {
                if(parts.length > 2) {
                    String id = parts[2];
                    if(id != playerID) return;                        
                }
                List<Player> players = (List<Player>) getObjects(Player.class);
                double x;
                double y;
                String mode;
                int ammo;
                int direction;
                double speed;
                for(Player pl : players) {
                    if(pl.id == playerID) {
                        x = pl.getWorldX();
                        y = pl.getWorldY();
                        //mode = pl.mode;
                        ammo = pl.ammo;
                        direction = pl.direction;
                        speed = pl.speed;
                        Join.send("playerDATA:"+playerID+";"+age+";"+ammo+";"+x+";"+y+";"+direction+";"+speed);
                    }
                }                    
            }
        }else if(name.equalsIgnoreCase("Anser")) {
            String subName = parts[1];
            if(subName.equalsIgnoreCase("playerID")) {
                String info = parts[2];
                String[] infoParts = info.split(";");
                String id = infoParts[0];
                long hisAge = Long.valueOf(infoParts[1]);
                if(knowIDs.contains(id) == false) knowIDs.add(id);

            }
        }else if(name.equalsIgnoreCase("To")) {
            if(parts[1].equals(playerID)) {
                String usedData = "";
                for(int i = 2; i < parts.length;i++) {
                    usedData+=parts[i]+":";
                }
                reicive(usedData);
            }
        }else if(name.equalsIgnoreCase("playerDATA")) {
            //handles a player update
            String info = parts[1];
            String[] infoParts = info.split(";");
            String id = infoParts[0];
            if(knowIDs.contains(id) == false) knowIDs.add(id);
            long hisAge = Long.valueOf(infoParts[1]);
            List<Player> players = (List<Player>) getObjects(Player.class);
            boolean inWorld = false;
            //String mode = infoParts[2];
            int ammo = Integer.valueOf(infoParts[2]);                        
            double x = Double.valueOf(infoParts[3]);
            double y = Double.valueOf(infoParts[4]);
            int direction = Integer.valueOf(infoParts[5]);
            double speed = Double.valueOf(infoParts[6]);
            for(Player pl : players) {  
                if(pl.id == id) {
                    inWorld = true;
                    pl.setWorldLoc(x,y);
                    pl.ammo = ammo;
                    //pl.mode = mode;
                    pl.direction = direction;
                    pl.speed = speed;
                }                        
            }

            if(inWorld == false) {
                Player pl = new Player(id);
                addPlayer(pl,x,y);
                pl.ammo = ammo;
                //pl.mode = mode;
                pl.direction = direction;
                pl.speed = speed;
            }
        }else if(name.equalsIgnoreCase("playerLoc") || name.equalsIgnoreCase("playerLocation")) {
            String info = parts[1];
            String[] infoParts = info.split(";");
            String id = infoParts[0];
            double x = Double.valueOf(infoParts[1]);
            double y = Double.valueOf(infoParts[2]);
            List<Player> players = (List<Player>) getObjects(Player.class);
            boolean inWorld = false;
            for(Player pl : players) {  
                if(pl.id == id) {
                    inWorld = true;
                    pl.setWorldLoc(x,y);
                    break;
                }                        
            }

            if(inWorld == false) {
                Join.send("Request:playerData:"+id);                    
            }
            
            //if a player moves try unloading stuff
            List<BaseActor> actors = (List<BaseActor>) getObjects(BaseActor.class);            
            for(BaseActor a : actors) {
                boolean remove = true;
                for(Player pl : players) {
                    Point p = pl.getWorldLoc();
                    if(p.distance(a.getWorldX(),a.getWorldY()) < 1000) {
                        remove = false;
                        break;
                    }
                }
                
                if(remove) {
                    removeObject(a);
                }
            }
        }else if(name.equalsIgnoreCase("ObstacleEvent")) {
            String subName = parts[1];
            if(subName.equalsIgnoreCase("Rock")) {
                String[] info = parts[2].split(";");
                double x = Double.valueOf(info[0]);
                double y = Double.valueOf(info[1]);
                addObjectAt(new Rock(),x,y);
            }
        }else if(name.equalsIgnoreCase("BoomerangEvent")) {
            String[] info = parts[1].split(";");
            String throwerID = info[0];
            int direction = Integer.valueOf(info[1]);
            double x = Double.valueOf(info[2]);
            double y = Double.valueOf(info[3]);
            
            List<Thrower> knownThrowers = (List<Thrower>) getObjects(Thrower.class);
            for(Thrower t : knownThrowers) {
                if(t.getID() == throwerID) {
                    addObjectAt(new Boomerang(t,direction),x,y);
                }
            }
        }
        /*}catch(IOException e) {
        System.err.println("IOException:"+e);
        e.printStackTrace();
        }*/
    }

    public void myJoinEvent(double x,double y,String name) {
        Join.send("JoinEvent:"+x+";"+y+";"+name);
        playerID = name;
        knowIDs.add(name);
        age = System.currentTimeMillis();                        
        addPlayer(new Player(playerID),x,y);        

        Join.send("Request:playerDATA");
    }
}
