import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Point;
import java.util.List;
/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends BaseActor implements Thrower
{
    

    String id;
    //String mode;
    public Player(String ID) {
        id = ID;
        setCollisionImage(new GreenfootImage(1,1));
        //mode = "boomerang";
        //player.add(this);
    }

    PlayWorld w;
    public void run() 
    {        
        w = (PlayWorld) getWorld();
        if(id != w.playerID && w.multiplayer)  return;
        move();     
        
    }   

    int direction = 0;
    double speed = 10.0;
    public void move() {        
        
        boolean straving = Greenfoot.isKeyDown(Control.strave);
        if(w == null) return;
        //System.out.println("move");
        if(Greenfoot.isKeyDown(Control.shoot))  {            
            shoot();
        }  
        boolean moved = true;
        if(Greenfoot.isKeyDown(Control.up))  {
            //System.out.println("upped");
            changeLoc(0,-speed);
            if(isTouching(Obstacle.class)) {
                //System.out.println("collided");
                changeLoc(0,+speed);
                return;
            }
            changeLoc(0,+speed);
            w.move(this,0,-speed);       
            if(straving == false) direction = 0;
        }else if(Greenfoot.isKeyDown(Control.down))  {
            changeLoc(0,+speed);
            if(isTouching(Obstacle.class)) {
                changeLoc(0,-speed);
                return;
            }
            changeLoc(0,-speed);
            w.move(this,0,speed);          
            if(straving == false) direction = 1;
        }else if(Greenfoot.isKeyDown(Control.left))  {
            changeLoc(-speed,0);
            if(isTouching(Obstacle.class)) {
                changeLoc(speed,0);
                return;
            }
            changeLoc(speed,0);
            w.move(this,-speed,0);           
            if(straving == false) direction = 2;
        }else if(Greenfoot.isKeyDown(Control.right))  {
            changeLoc(speed,0);
            if(isTouching(Obstacle.class)) {
                changeLoc(-speed,0);
                return;
            }
            changeLoc(-speed,0);
            w.move(this,+speed,0);          
            if(straving == false) direction = 3;
        }else moved = false;

        if(moved && w.multiplayer) {
            Join.send("playerLoc:"+getWorldX()+";"+getWorldY());
        }    
        
        if(moved) {
            List<BaseActor> actors = (List<BaseActor>) w.getObjects(BaseActor.class);
            List<Player> players = (List<Player>) w.getObjects(Player.class);
            for(BaseActor a : actors) {
                boolean remove = true;
                for(Player pl : players) {
                    Point p = pl.getWorldLoc();
                    if(p.distance(a.getWorldX(),a.getWorldY()) < 1000) {
                        remove = false;
                        break;
                    }
                }
                
                if(remove) {
                    w.removeObject(a);
                }
            }
        }
    }

    int ammo = 1;
    public void shoot() {
        if(ammo > 0)  {
            getWorld().addObject(new Boomerang(this,direction),getX(),getY());
            ammo--;
        }
    }

    public void addedToWorld(PlayWorld w) {
        while(getObjectsInRange(600,Obstacle.class).size() < 18)   w.addObject(Obstacle.Obstacle(),getX()+(Greenfoot.getRandomNumber(1200)-600),getY()+(Greenfoot.getRandomNumber(1200)));
        w.addObject(new ObstacleGenerator(this),getX(),getY());
    }

    public double getSpeed() {
        return speed;
    }

    public int getAmmo() {
        return ammo;
    }

    public void setAmmo(int ammo) {
        this.ammo = ammo;
    }

    public double getAttack() {
        return 1;
    }

    double health = 3.0;
    public void damage(double amount) {
        health-=amount;
        if(health < 0) {
            death();
        }
    }

    public double getHealth() {
        return health;
    }

    public void death() {

    }

    public GreenfootImage getThroweablesImage() {
        return new GreenfootImage(20,20);
    } 
    
    public String getID() {
        return id;
    }
}
